VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1920
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2985
   LinkTopic       =   "Form1"
   ScaleHeight     =   1920
   ScaleWidth      =   2985
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Height          =   375
      Left            =   1680
      TabIndex        =   11
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtVolume 
      Height          =   285
      Left            =   960
      TabIndex        =   10
      Text            =   "C:\"
      Top             =   240
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "Volume"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   240
      Width           =   615
   End
   Begin VB.Label lblPercentTotal 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   2040
      TabIndex        =   8
      Top             =   720
      Width           =   735
   End
   Begin VB.Label lblPercentUsed 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   2040
      TabIndex        =   7
      Top             =   1440
      Width           =   735
   End
   Begin VB.Label lblPercentFree 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   2040
      TabIndex        =   6
      Top             =   1080
      Width           =   735
   End
   Begin VB.Label lblUsed 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   960
      TabIndex        =   5
      Top             =   1440
      Width           =   855
   End
   Begin VB.Label lblFree 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   960
      TabIndex        =   4
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Total:"
      Height          =   255
      Index           =   2
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Used:"
      Height          =   255
      Index           =   1
      Left            =   240
      TabIndex        =   2
      Top             =   1440
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Free:"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   615
   End
   Begin VB.Label lblTotal 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   960
      TabIndex        =   0
      Top             =   720
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpRootPathName As String, lpFreeBytesAvailableToCaller As LARGE_INTEGER, lpTotalNumberOfBytes As LARGE_INTEGER, lpTotalNumberOfFreeBytes As LARGE_INTEGER) As Long
' Convert a LARGE_INTEGER structure into
' data type to a Double.
Private Function LargeIntegerToDouble(low_part As Long, high_part As Long) As Double
Dim result As Double

    result = high_part
    If high_part < 0 Then result = result + 2 ^ 32
    result = result * 2 ^ 32

    result = result + low_part
    If low_part < 0 Then result = result + 2 ^ 32

    LargeIntegerToDouble = result
End Function
' Get the free space.
Private Sub GetFreeSpace(ByVal drive_letter As String, ByRef total_size As Double, ByRef total_free As Double)

    If GetDiskFreeSpace(drive_letter & ":\", _
        sectors_per_cluster, _
        bytes_per_sector, _
        num_free_clusters, _
        total_clusters) _
    Then
        total_size = total_clusters * sectors_per_cluster * bytes_per_sector
        total_free = num_free_clusters * sectors_per_cluster * bytes_per_sector
    Else
        total_size = 0
        total_free = 0
    End If
End Sub

Private Function SizeString(ByVal num_bytes As Double) As String
Const SIZE_KB As Double = 1024
Const SIZE_MB As Double = 1024 * SIZE_KB
Const SIZE_GB As Double = 1024 * SIZE_MB
Const SIZE_TB As Double = 1024 * SIZE_GB

    If num_bytes < SIZE_KB Then
        SizeString = Format$(num_bytes) & " bytes"
    ElseIf num_bytes < SIZE_MB Then
        SizeString = Format$(num_bytes / SIZE_KB, "0.00") & " KB"
    ElseIf num_bytes < SIZE_GB Then
        SizeString = Format$(num_bytes / SIZE_MB, "0.00") & " MB"
    Else
        SizeString = Format$(num_bytes / SIZE_GB, "0.00") & " GB"
    End If
End Function

Private Sub cmdGo_Click()
Dim bytes_avail As LARGE_INTEGER
Dim bytes_total As LARGE_INTEGER
Dim bytes_free As LARGE_INTEGER
Dim dbl_total As Double
Dim dbl_free As Double

    ' Get the space values.
    GetDiskFreeSpaceEx "C:\", bytes_avail, bytes_total, bytes_free

    ' Convert values into Doubles.
    dbl_total = LargeIntegerToDouble(bytes_total.lowpart, bytes_total.highpart)
    dbl_free = LargeIntegerToDouble(bytes_free.lowpart, bytes_free.highpart)

    lblTotal.Caption = SizeString(dbl_total)
    lblFree.Caption = SizeString(dbl_free)
    lblUsed.Caption = SizeString(dbl_total - dbl_free)
    lblPercentTotal.Caption = Format$(1, "percent")
    lblPercentFree.Caption = Format$(dbl_free / dbl_total, "percent")
    lblPercentUsed.Caption = Format$((dbl_total - dbl_free) / dbl_total, "percent")
End Sub
